from struct import *
from tsctl import *
from array import *

NetAIO_VoltageRangeList=4
NetAIOClass=9

class AIO:
    def __init__(self,tsctl,instance):
        self.tsctl = tsctl
        self.inst = instance

    def __del__(self):
        del self.tsctl

    def VoltageRangeList(self):
        data1=pack('<HBB',NetAIOClass,self.inst,NetAIO_VoltageRangeList)
        self.tsctl.send(data1,True)
        reply0=unpack('<HBBi',self.tsctl.recv(8))
        if reply0[0] != NetAIOClass: raise Exception(1,reply0)
        if reply0[1] != NetAIO_VoltageRangeList: raise Exception(2,reply0)
        if reply0[2] != 0x70: raise Exception(3,reply0)
        ret = []
        for i in xrange(reply0[3]):
            reply=unpack('<BBfBfBiBBfBfBi',self.tsctl.recv(32))
            if reply[0] != 0x31: raise Exception(4,reply)
            if reply[1] != 0x23: raise Exception(5,reply)
            if reply[3] != 0x23: raise Exception(6,reply)
            if reply[5] != 0x03: raise Exception(7,reply)
            if reply[7] != 0x31: raise Exception(8,reply)
            if reply[8] != 0x23: raise Exception(9,reply)
            if reply[10] != 0x23: raise Exception(10,reply)
            if reply[12] != 0x03: raise Exception(11,reply)
            ret.append([reply[2],reply[4],reply[6],reply[9],reply[11],reply[13]])
        reply=unpack('<B',self.tsctl.recv(1))
        if reply[0] != 0x80: raise Exception(12,reply)
        return ret
