#!/usr/bin/python

import socket
import sys
from struct import *
from tsctl import *
from array import *

LOW=0
HIGH=1
INPUT=-1
INPUT_HIGH=-2
INPUT_LOW=-3

NetDIO_Lock=0 
NetDIO_Refresh=3
NetDIO_Commit=4
NetDIO_Set=5
NetDIO_Get=6
NetDIO_SetAsync=7
NetDIO_GetAsync=8
NetDIO_Wait=9
NetDIO_Count=10

NetDIOClass=5

class DIO:
    def __init__(self,tsctl,instance):
        self.tsctl = tsctl
        self.inst=instance

    def __del__(self):
        del self.tsctl

    def SetAsync(self,DIONum,state):
        data1=pack('<HBBii',NetDIOClass,self.inst,NetDIO_SetAsync,DIONum,state)
        self.tsctl.send(data1,False)
        if self.tsctl.mode > 0: return
        reply=unpack('<HBB',self.tsctl.recv(4))
        if reply[0] != NetDIOClass: raise Exception(1)
        if reply[1] != NetDIO_SetAsync: raise Exception(reply)
        if reply[2] != 0x80: raise Exception(reply)
        return

    def GetAsync(self,DIONum):
        data1=pack('<HBBi',NetDIOClass,self.inst,NetDIO_GetAsync,DIONum)
        self.tsctl.send(data1,True)
        reply=unpack('<HBBiB',self.tsctl.recv(9))
        if reply[0] != NetDIOClass: raise Exception(reply)
        if reply[1] != NetDIO_GetAsync: raise Exception(reply)
        if reply[2] != 0xC4: raise Exception(reply)
        if reply[4] != 0x80: raise Exception(reply)
        return reply[3]

# Author: Michael Schmidt (michael@embeddedARM.com)
# Copyright (c) 2013, Technologic Systems, All Rights Reserved
# Refer to the COPYRIGHT file provided with this project for licensing terms.
