from struct import *
from tsctl import *
from array import *

NetSystem_ClassCount=0
NetSystem_InstanceCount=1
NetSystem_APICount=2
NetSystem_LockCount=3
NetSystem_LockHolderInfo=4
NetSystem_ConnWaitInfo=5
NetSystem_CANBusGet=6
NetSystem_BuildTime=7
NetSystem_ModelId=8
NetSystem_BaseBoardId=9
NetSystem_MapLookup=12
NetSystem_MapLookupPartial=13
NetSystemClass=0

class System:
    def __init__(self,tsctl,instance):
        self.tsctl = tsctl
        self.inst = instance

    def __del__(self):
        del self.tsctl


    def MapLookup(self,arr8):
        data1=pack('<HBBi'+str(len(arr8))+'s',NetSystemClass,self.inst,
                   NetSystem_MapLookup,len(arr8),arr8.tostring())
        self.tsctl.send(data1,True)
        reply=unpack('<HBBiB',self.tsctl.recv(9))
        if reply[0] != NetSystemClass: raise Exception(reply)
        if reply[1] != NetSystem_MapLookup: raise Exception(reply)
        if reply[2] != 0x13: raise Exception(reply)
        if reply[4] != 0x80: raise Exception(reply)
        return reply[3]

    def MapLookupPartial(self,prefix,val):
        data1=pack('<HBBi'+str(len(prefix))+'si',NetSystemClass,self.inst,
                   NetSystem_MapLookupPartial,
                   len(prefix),prefix.tostring(),val)
        self.tsctl.send(data1,True)
        reply=unpack('<HBBi',self.tsctl.recv(8))
        if reply[0] != NetSystemClass: raise Exception(reply)
        if reply[1] != NetSystem_MapLookupPartial: raise Exception(reply)
        if reply[2] != 0x50: raise Exception(reply)
        reply=unpack('<'+str(reply[3])+'sB',self.tsctl.recv(1+reply[3]))
        if reply[1] != 0x80: raise Exception(reply)
        return reply[0]



# Author: Michael Schmidt (michael@embeddedARM.com)
# Copyright (c) 2011, Technologic Systems, All Rights Reserved
# Refer to the COPYRIGHT file provided with this project for licensing terms.
