#!/usr/bin/python

import socket
import sys
from struct import *

NetModeBlocking=0 # all calls block until server returns completion
NetModeNonBlocking=1 # calls to functions return void return immediately
NetModeQueued=2 #  we don't send commands to server until 
# function returning non-void is called.

class tsctl:
    
    def recv(self,bytes):
        print "recv "+str(bytes)
        ret = ""
        while bytes > 0:
            got = self.s.recv(bytes)
            if len(got) == 0:
                return ret
            bytes -= len(got)
            ret = ret + got
        return ret

    def send(self,data,retter):
        if self.mode > 0 and not retter:
            self.count = self.count+1
        if self.mode < 2 or retter:
            print "send "+str(len(self.q))+"+"+str(len(data))
            self.s.send(self.q+data)
            self.q=""
        else:
            self.q += data
        if self.mode > 0 and not retter:
            return
        if self.count > 0:
            self.recv(4*self.count)
            self.count = 0

    def __init__(self,server,mode=NetModeBlocking):
        self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.s.connect((server,5001))
        self.sever = server
        self.mode=mode
        self.count=0
        self.q=""

    def __del__(self):
        self.s.close()

    def reset(self):
        self.s.close()
        self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.s.connect((self.server,5001))



# Author: Michael Schmidt (michael@embeddedARM.com)
# Copyright (c) 2013, Technologic Systems, All Rights Reserved
# Refer to the COPYRIGHT file provided with this project for licensing terms.
